<?php
defined('BASEPATH') OR exit('No direct script access allowed');
header('Access-Control-Allow-Origin: *'); 

class Report_new extends CI_Controller {
    public function __construct() 
    {
    	//error_reporting(0);
        parent::__construct();  
        $this->load->library('Multiquery'); 
    }
    public function getPermiseFilters($user_id){
        
        $statuses =  $this->db->get('ptsl_accountstatus')->result_array();
        $types =  $this->db->get('ptsl_accounttype')->result_array();
        $packs =  $this->db->get('ptsl_container')->result_array();
        $channels = $this->db->get('ptsl_accountchannel')->result_array();
        $this->db->select('distinct(state)');
        $states =  $this->db->get('ptsl_accountinfo')->result_array();
        $spn= "Call ptsl_sp_get_distributors_for_supplier('".$user_id."');";
        $distributors = $this->db->query($spn)->result_array();
        if($types){
             $response = array(
                'status' => TRUE,
                'distributors' => $distributors,
                'statuses'=> $statuses,
                'types' =>$types,
                'packs'=> $packs,
                'states'=>$states,
                'channels' => $channels
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function get_distributors($user_id){
        $spn = "Call ptsl_sp_get_distributors_for_supplier('".$user_id."')";
        $res = $this->db->query($spn)->result_array();
        if($res){
             $response = array(
                'status' => TRUE,
                'distributors' => $res,
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function report_by_activity(){
         $user_id = $this->input->get('user_id');
         $distributor_id = @$this->input->get('distributor_id');
         $activity_type = @$this->input->get('activity_type');
         
         $year = @$this->input->get('year');
         $quarter = @$this->input->get('quarter');
         $spn = "Call ptsl_sp_visit_event_rpt('".$user_id."','".$distributor_id."', '".$year."' , '".$quarter."' , '".$activity_type."')";
         //echo $spn;
         $res = $this->multiquery->GetResults($spn);
         //print_r($res);
         if($res){
             $response = array(
                'status' => TRUE,
                'activity_report' => $res[4],
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function report_by_recact(){
         $user_id = $this->input->get('user_id');
         $distributor_id = @$this->input->get('distributor_id');
         $is_week = @$this->input->get('is_week');
         $rep = @$this->input->get('rep');
         $year = @$this->input->get('year');
         $quarter = @$this->input->get('quarter');
         $spn = "Call ptsl_sp_recent_activity_rpt('".$user_id."','".$distributor_id."', '".$year."' , '".$quarter."' , '".$is_week."','".$rep."')";
         //echo $spn;
         $res = $this->multiquery->GetResults($spn);
         //print_r($res[3]);
         if($res){
             $response = array(
                'status' => TRUE,
                'activity_report' => $res[3],
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function report_by_brandexp(){
         $user_id = $this->input->get('user_id');

         $year = @$this->input->get('year');
         $quarter = @$this->input->get('quarter');
         $spn = "call ptsl_sp_brand_exposure_rpt('".$user_id."', '".$year."', '".$quarter."')";
         //echo $spn;
         $res = $this->multiquery->GetResults($spn);
         //print_r($res);
         if($res){
             $response = array(
                'status' => TRUE,
                'brandexp_report' => $res[4],
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function TopOnPremise(){
        $user_id = @$this->input->get('user_id');
        $limit = @$this->input->get('limit');
        //$channelid = @$this->input->get('channelid');
        $channelid = 1;
        $account_status = @$this->input->get('account_status');
        $packaging = @$this->input->get('packaging');
        $account_type = @$this->input->get('account_type');
        $state = @$this->input->get('state');
        $distributor_id = @$this->input->get('distributor_id');
        $zipcode = @$this->input->get('zipcode');
        $ismap = @$this->input->get('ismap');
        $overdue = @$this->input->get('overdue');
        $myaccount = @$this->input->get('myaccount');
        $rep = @$this->input->get('rep');
        $spn = "Call  ptsl_sp_get_top_onoff_premise_report('".$user_id."','".$limit."','".$channelid."','".$account_status."','".$packaging."','".$account_type."','".$state."','".$distributor_id."','".$zipcode."','".$overdue."','".$myaccount."','".$rep."')"; //,'".$ismap."'
        $data = $this->db->query($spn)->result_array();
        $geocode_array = array();
        $cnt = 0;
        $len=count($data);
        foreach ($data as $key => $account) {
            if($account['latitude']){
                $address = $account['address'];
                $name = $account['LongName'];
                $link = '<div class="sum_wrap"><div class="sum2">'.'<a href="#/clientresult/'.$account["AccountID"].'">Go to Account</a></div>';
                $link2 = '<div class="sum3">'.'<a href="#/addplanner/'.$account["AccountID"].'">Add to Planner</a></div></div>';
                $geocode_array[$cnt][0] = '<div class="summary">'.$name.'</div>'.'<br /><br />'.$address.'<br/><br/>'.$link."&nbsp; &nbsp;".$link2;
                $geocode_array[$cnt][1] = $account['latitude'];
                $geocode_array[$cnt][2] = $account['longitude'];
                $cnt++;
            }
        }
        if($data){
             $response = array(
                'status' => TRUE,
                'TopOnPremisereports' => $data,
                'locations' => $geocode_array,
                'len' => count($geocode_array)
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function TopOffPremise(){
        $user_id = @$this->input->get('user_id');
        $limit = @$this->input->get('limit');
        //$channelid = @$this->input->get('channelid');
        $channelid = 2;
        $account_status = @$this->input->get('account_status');
        $packaging = @$this->input->get('packaging');
        $account_type = @$this->input->get('account_type');
        $state = @$this->input->get('state');
        $distributor_id = @$this->input->get('distributor_id');
        $zipcode = @$this->input->get('zipcode');
        $ismap = @$this->input->get('ismap');
        $overdue = @$this->input->get('overdue');
        $myaccount = @$this->input->get('myaccount');
        $rep = @$this->input->get('rep');
        $spn = "Call  ptsl_sp_get_top_onoff_premise_report('".$user_id."','".$limit."','".$channelid."','".$account_status."','".$packaging."','".$account_type."','".$state."','".$distributor_id."','".$zipcode."','".$overdue."','".$myaccount."','".$rep."')"; //,'".$ismap."'
        $data = $this->db->query($spn)->result_array();
        $geocode_array = array();
        $cnt = 0;
        $len=count($data);
        foreach ($data as $key => $account) {
            if($account['latitude']){
                $address = $account['address'];
                $name = $account['LongName'];
                $link = '<div class="sum_wrap"><div class="sum2">'.'<a href="#/clientresult/'.$account["AccountID"].'">Go to Account</a></div>';
                $link2 = '<div class="sum3">'.'<a href="#/addplanner/'.$account["AccountID"].'">Add to Planner</a></div></div>';
                $geocode_array[$cnt][0] = '<div class="summary">'.$name.'</div>'.'<br /><br />'.$address.'<br/><br/>'.$link."&nbsp; &nbsp;".$link2;
                $geocode_array[$cnt][1] = $account['latitude'];
                $geocode_array[$cnt][2] = $account['longitude'];
                $cnt++;
            }
        }
        if($data){
             $response = array(
                'status' => TRUE,
                'TopOnPremisereports' => $data,
                'locations' => $geocode_array,
                'len' => count($geocode_array)
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function TopDraft(){
        $user_id = @$this->input->get('user_id');
        $limit = @$this->input->get('limit');
        //$channelid = @$this->input->get('channelid');
        $channelid = '';
        $account_status = @$this->input->get('account_status');
        //$packaging = @$this->input->get('packaging');
        $packaging = '';
        $account_type = @$this->input->get('account_type');
        $state = @$this->input->get('state');
        $distributor_id = @$this->input->get('distributor_id');
        $zipcode = @$this->input->get('zipcode');
        $ismap = @$this->input->get('ismap');
        $overdue = @$this->input->get('overdue');
        $myaccount = @$this->input->get('myaccount');
        $rep = @$this->input->get('rep');
        $spn = "Call  ptsl_sp_get_top_draft_report('".$user_id."','".$limit."','".$channelid."','".$account_status."','".$packaging."','".$account_type."','".$state."','".$distributor_id."','".$zipcode."','".$overdue."','".$myaccount."','".$rep."')"; //,'".$ismap."'
       // echo $spn;
        $data = $this->db->query($spn)->result_array();
        $geocode_array = array();
        $cnt = 0;
        $len=count($data);
        foreach ($data as $key => $account) {
            if($account['latitude']){
                $address = $account['address'];
                $name = $account['LongName'];
                $link = '<div class="sum_wrap"><div class="sum2">'.'<a href="#/clientresult/'.$account["AccountID"].'">Go to Account</a></div>';
                $link2 = '<div class="sum3">'.'<a href="#/addplanner/'.$account["AccountID"].'">Add to Planner</a></div></div>';
                $geocode_array[$cnt][0] = '<div class="summary">'.$name.'</div>'.'<br /><br />'.$address.'<br/><br/>'.$link."&nbsp; &nbsp;".$link2;
                $geocode_array[$cnt][1] = $account['latitude'];
                $geocode_array[$cnt][2] = $account['longitude'];
                $cnt++;
            }
        }
        if($data){
             $response = array(
                'status' => TRUE,
                'TopDraftreports' => $data,
                'locations' => $geocode_array,
                'len' => count($geocode_array)
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }
    public function LostAccounts(){
        $user_id = @$this->input->get('user_id');
        $limit = @$this->input->get('limit');
        //$channelid = @$this->input->get('channelid');
        $channelid = '';
        $channel = @$this->input->get('channel');
        //$packaging = @$this->input->get('packaging');
        $packaging = '';
        $account_type = @$this->input->get('type');
        $state = @$this->input->get('state');
        $distributor_id = @$this->input->get('distributor_id');
        $zipcode = @$this->input->get('zipcode');
        $ismap = @$this->input->get('ismap');
         $overdue = @$this->input->get('overdue');
         $myaccount = @$this->input->get('myaccount');
        $rep = @$this->input->get('rep');
        $spn = "Call  ptsl_sp_get_lost_accounts_report('".$user_id."','".$limit."','".$channelid."','".$channel."','".$packaging."','".$account_type."','".$state."','".$distributor_id."','".$zipcode."','".$overdue."','".$myaccount."','".$rep."')"; //,'".$ismap."'
        //echo $spn;
        $data = $this->db->query($spn)->result_array();
        $geocode_array = array();
        $cnt = 0;
        $len=count($data);
        foreach ($data as $key => $account) {
            if($account['latitude']){
                $address = $account['address'];
                $name = $account['LongName'];
                $link = '<div class="sum_wrap"><div class="sum2">'.'<a href="#/clientresult/'.$account["AccountID"].'">Go to Account</a></div>';
                $link2 = '<div class="sum3">'.'<a href="#/addplanner/'.$account["AccountID"].'">Add to Planner</a></div></div>';
                $geocode_array[$cnt][0] = '<div class="summary">'.$name.'</div>'.'<br /><br />'.$address.'<br/><br/>'.$link."&nbsp; &nbsp;".$link2;
                $geocode_array[$cnt][1] = $account['latitude'];
                $geocode_array[$cnt][2] = $account['longitude'];
                $cnt++;
            }
        }
        if($data){
             $response = array(
                'status' => TRUE,
                'lostaccounts' => $data,
                'locations' => $geocode_array,
                'len' => count($geocode_array)
            );
            echo json_encode($response);
        }
        else{
             $response = array(
                'status' => False,
                'message' => "No Data Found"
            );
        echo json_encode($response);
        }
    }

    public function report_bypermise_init(){
        $user_id = $this->input->get('user_id');
        $is_sales = $this->input->get('is_sales');
        $channel = $this->input->get('channel');
        $year = @$this->input->get('year');
        $sku = @$this->input->get('sku');
        $brand = @$this->input->get('brand');
        $state = @$this->input->get('state');
        $region = @$this->input->get('region');
        $quarter = @$this->input->get('quarter');
        $data = $this->db->get_where('ptsl_report_config',array('report_id'=>6))->result_array();
        $default_month = $data[0]['default_month'];
        $labels =array();
        $color_array = array('#5C80B8','#B15751');
        $spn = "Call ptsl_sp_sales_by_channel_growth('".$user_id."','".$default_month."','".$is_sales."','".$year."','".$channel."','".$brand."','".$sku."','".$state."','".$quarter."','".$region."')";
      
        $cdata = $this->multiquery->GetResults($spn);
        $data = $cdata[2][0];
        $previous_yr_sum = ceil($data['sum_p']);
        $current_yr_sum  = ceil($data['sum_c']);
        $growth = 0;
        $percentage = 0;
        $grid_data = array();
        if($previous_yr_sum<$current_yr_sum){
            $growth =1;
            if($current_yr_sum!=0 || $current_yr_sum!=null){
               $percentage = ((-$previous_yr_sum+$current_yr_sum)/$current_yr_sum)*100; 
            }
            
        }else{
            $growth = -1;
             if($previous_yr_sum!=0 || $previous_yr_sum!=null){
                $percentage = (($previous_yr_sum-$current_yr_sum)/$previous_yr_sum)*100;
            }
        }
        if(count($cdata)>5){
           $grid_data = $cdata[5];  
        }
        $list_view = array();
        $converted_array = array($data['sum_p'],$data['sum_c']);	
 		    $labels = array($data['priv_label'] ,$data['current_label'] );	
            if($converted_array){
                $response = array(
                     'status' => TRUE,
                     'premise_report' => $converted_array,
                     'len' => count($converted_array),
                     'labels' => $labels,
                     'colors' => $color_array,
                     'fetched_data' => $grid_data,
                     'growth' =>$growth,
                     'percentage'=> ceil($percentage)
                     );
                echo json_encode($response);
            }
            else{
                $response = array(
                    'status' => False,
                     'message' => "No Data Found"
                );
                echo json_encode($response);
            }
   }
   public function report_bystate_init(){
        $user_id = $this->input->get('user_id');
        $is_sales = $this->input->get('is_sales');
        $channel = $this->input->get('channel');
        $year = @$this->input->get('year');
        $sku = @$this->input->get('sku');
        $brand = @$this->input->get('brand');
        $state = @$this->input->get('state');
        $region = @$this->input->get('region');
        $quarter = @$this->input->get('quarter');
        $data = $this->db->get_where('ptsl_report_config',array('report_id'=>5))->result_array();
        $default_month = $data[0]['default_month'];
        $labels =array();
        $color_array = array('#5C80B8','#B15751');
        $spn = "Call ptsl_sp_sales_by_state_growth('".$user_id."','".$default_month."','".$is_sales."','".$year."','".$channel."','".$brand."','".$sku."','".$state."','".$quarter."','".$region."')";
      
        $cdata = $this->multiquery->GetResults($spn);
        //print_r($cdata);
        $data = $cdata[2][0];
        $previous_yr_sum = ceil($data['sum_p']);
        $current_yr_sum  = ceil($data['sum_c']);
        $growth = 0;
        $percentage = 0;
        $grid_data = array();
        if($previous_yr_sum<$current_yr_sum){
            $growth =1;
            if($current_yr_sum!=0 || $current_yr_sum!=null){
               $percentage = ((-$previous_yr_sum+$current_yr_sum)/$current_yr_sum)*100; 
            }
            
        }else{
            $growth = -1;
             if($previous_yr_sum!=0 || $previous_yr_sum!=null){
                $percentage = (($previous_yr_sum-$current_yr_sum)/$previous_yr_sum)*100;
            }
        }
        if(count($cdata)>5){
           $grid_data = $cdata[5];  
        }
        $list_view = array();
        $converted_array = array($data['sum_p'],$data['sum_c']);    
        $labels = array($data['priv_label'] ,$data['current_label'] );
            if($converted_array){
                $response = array(
                     'status' => TRUE,
                     'state_report' => $converted_array,
                     'len' => count($converted_array),
                     'labels' => $labels,
                     'colors' => $color_array,
                     'fetched_data' => $grid_data,
                     'growth' =>$growth,
                     'percentage'=> ceil($percentage)
                     );
                echo json_encode($response);
            }
            else{
                $response = array(
                    'status' => False,
                     'message' => "No Data Found"
                );
                echo json_encode($response);
            }
   }
   public function get_brandfiterdata_init(){
        $user_id = $this->input->get('user_id');
        $is_sales = $this->input->get('is_sales');
        $channel = $this->input->get('channel');
        $year = @$this->input->get('year');
        $sku = @$this->input->get('sku');
        $brand = @$this->input->get('brand');
        $state = @$this->input->get('state');
        $region = @$this->input->get('region');
        $quarter = @$this->input->get('quarter');
        $data = $this->db->get_where('ptsl_report_config',array('report_id'=>4))->result_array();
        $default_month = $data[0]['default_month'];
        $labels =array();
        $color_array = array('#5C80B8','#B15751');
        $spn = "Call ptsl_sp_sales_by_brand_growth('".$user_id."','".$default_month."','".$is_sales."','".$year."','".$channel."','".$brand."','".$sku."','".$state."','".$quarter."','".$region."')";
      
        $cdata = $this->multiquery->GetResults($spn);
        //print_r($cdata);
        $data = $cdata[2][0];
        $previous_yr_sum = ceil($data['sum_p']);
        $current_yr_sum  = ceil($data['sum_c']);
        $growth = 0;
        $percentage = 0;
        $grid_data = array();
        if($previous_yr_sum<$current_yr_sum){
            $growth =1;
            if($current_yr_sum!=0 || $current_yr_sum!=null){
               $percentage = ((-$previous_yr_sum+$current_yr_sum)/$current_yr_sum)*100; 
            }
            
        }else{
            $growth = -1;
             if($previous_yr_sum!=0 || $previous_yr_sum!=null){
                $percentage = (($previous_yr_sum-$current_yr_sum)/$previous_yr_sum)*100;
            }
        }
        if(count($cdata)>5){
           $grid_data = $cdata[5];  
        }
        $list_view = array();
        $converted_array = array($data['sum_p'],$data['sum_c']);    
        $labels = array($data['priv_label'] ,$data['current_label'] );  
            if($converted_array){
                $response = array(
                     'status' => TRUE,
                     'state_report' => $converted_array,
                     'len' => count($converted_array),
                     'labels' => $labels,
                     'colors' => $color_array,
                     'fetched_data' => $grid_data,
                     'growth' =>$growth,
                     'percentage'=> ceil($percentage)
                     );
                echo json_encode($response);
            }
            else{
                $response = array(
                    'status' => False,
                     'message' => "No Data Found"
                );
                echo json_encode($response);
            }
   }
    public function get_skufiterdata_init(){
        $user_id = $this->input->get('user_id');
        $is_sales = $this->input->get('is_sales');
        $channel = $this->input->get('channel');
        $year = @$this->input->get('year');
        $sku = @$this->input->get('sku');
        $brand = @$this->input->get('brand');
        $state = @$this->input->get('state');
        $region = @$this->input->get('region');
        $quarter = @$this->input->get('quarter');
        $data = $this->db->get_where('ptsl_report_config',array('report_id'=>7))->result_array();
        $default_month = $data[0]['default_month'];
        $labels =array();
        $color_array = array('#5C80B8','#B15751');
        $spn = "Call ptsl_sp_sales_by_package_growth('".$user_id."','".$default_month."','".$is_sales."','".$year."','".$channel."','".$brand."','".$sku."','".$state."','".$quarter."','".$region."')";
      
        $cdata = $this->multiquery->GetResults($spn);
        //print_r($cdata);
        $data = $cdata[2][0];
        $previous_yr_sum = ceil($data['sum_p']);
        $current_yr_sum  = ceil($data['sum_c']);
        $growth = 0;
        $percentage = 0;
        $grid_data = array();
        if($previous_yr_sum<$current_yr_sum){
            $growth =1;
            if($current_yr_sum!=0 || $current_yr_sum!=null){
               $percentage = ((-$previous_yr_sum+$current_yr_sum)/$current_yr_sum)*100; 
            }
            
        }else{
            $growth = -1;
             if($previous_yr_sum!=0 || $previous_yr_sum!=null){
                $percentage = (($previous_yr_sum-$current_yr_sum)/$previous_yr_sum)*100;
            }
        }
        if(count($cdata)>5){
           $grid_data = $cdata[5];  
        }
        $list_view = array();
        $converted_array = array($data['sum_p'],$data['sum_c']);    
        $labels = array($data['priv_label'] ,$data['current_label'] );  
            if($converted_array){
                $response = array(
                     'status' => TRUE,
                     'state_report' => $converted_array,
                     'len' => count($converted_array),
                     'labels' => $labels,
                     'colors' => $color_array,
                     'fetched_data' => $grid_data,
                     'growth' =>$growth,
                     'percentage'=> ceil($percentage)
                     );
                echo json_encode($response);
            }
            else{
                $response = array(
                    'status' => False,
                     'message' => "No Data Found"
                );
                echo json_encode($response);
            }
   }
}