<?php

defined('BASEPATH') OR exit('No direct script access allowed');

header('Access-Control-Allow-Origin: *'); 

class Auth extends CI_Controller {

	public function __construct() 

    {

        parent::__construct();

        

    }

	

	public function login(){

		$errors = array();

		$data = array();

		

		$post_data = json_decode(file_get_contents('php://input'), true);

		

		if (empty($post_data['username']))

			$errors['username'] = 'Username is required.';

		if (empty($post_data['password']))

			$errors['password'] = 'Password is required.';
		if (empty($post_data['player_id']))

			$errors['player_id'] = 'Device Token is required.';

		if($errors){

			$response = array(

					'status' => FALSE,

					'message' => 'Username and Password is required' 

				);

			echo json_encode($response);

			return;	 

		}

		$this->db->select('*');

		$this->db->where('login_name',$post_data['username']);	 

		$this->db->where('password',($post_data['password']));

		$this->db->where('is_active','1');
		$this->db->where('user_type_id is  NOT NULL');

		$data = $this->db->get('ptsl_users')->result_array();

		if($data){
			$this->db->select('id,config_name,config_value');
			$config_data = $this->db->get('ptsl_config')->result_array();
			$data_role = $this->db->get_where('ptsl_users_roles',array('user_id'=> $data[0]['user_id']))->result_array();
			$this->db->where('device_key',$post_data['player_id']);
			$this->db->where('user_id',$data[0]['user_id']);
			$has_player_id = $this->db->get('ptsl_push_notifications')->result_array();
			if(!$has_player_id){
				$insert_to_push_notification_table = array(
					'user_id' => $data[0]['user_id'],
					'device_key' => $post_data['player_id'],
					'is_active' => 1,
					'created_date' => date("Y-m-d H:i:s")
				);
				$this->db->insert('ptsl_push_notifications',$insert_to_push_notification_table);
			} 
			$response = array(
					'status'=> TRUE,
					'message'=> 'Login successful',
					'userid'=>$data[0]['user_id'],
					'user_type' => $data[0]['user_type_id'],
					'supplier' => $data[0]['supplier_id'],
					'distributor' => $data[0]['distributor_id'],
					
					'supplier_rep_id' => $data[0]['supplier_rep_id'],
					'supplier_manager_id' => $data[0]['supplier_manager_id'],
					'general_sales_manager_id'=> $data[0]['general_sales_manager_id'],
					'distributor_manager_id' => $data[0]['distributor_manager_id'],
					'distributor_rep_id' => $data[0]['distributor_rep_id'],
					'brand_manager_id' => $data[0]['brand_manager_id'],
					'config_id'=> $config_data[0]['id'],
					'image_quality_config'=> $config_data[0]['config_name'],
					'image_quality_value'=> $config_data[0]['config_value'],
					'role_id' =>@$data_role[0]['role_id']
				);
		}

		else{

			$response = array(

					'status'=> FALSE,

					'message'=> 'Login Failed'

				);

		}
		echo json_encode($response);

	}

}